diff --git a/gcc/cp/constraint.cc b/gcc/cp/constraint.cc
index 6d14ef7dcc7..8679d3ce658 100644
--- a/gcc/cp/constraint.cc
+++ b/gcc/cp/constraint.cc
@@ -3825,6 +3825,12 @@ diagnose_trait_expr (tree expr, tree args)
     case CPTK_IS_NOTHROW_CONVERTIBLE:
 	  inform (loc, "  %qT is not nothrow convertible from %qE", t2, t1);
       break;
+    case CPTK_IS_NOTHROW_INVOCABLE:
+	if (!t2)
+	  inform (loc, "  %qT is not nothrow invocable", t1);
+	else
+	  inform (loc, "  %qT is not nothrow invocable by %qE", t1, t2);
+	break;
     case CPTK_IS_OBJECT:
       inform (loc, "  %qT is not an object type", t1);
       break;
diff --git a/gcc/cp/cp-trait.def b/gcc/cp/cp-trait.def
index ca6a797e64d..52f8d05ea9f 100644
--- a/gcc/cp/cp-trait.def
+++ b/gcc/cp/cp-trait.def
@@ -84,6 +84,7 @@ DEFTRAIT_EXPR (IS_MEMBER_POINTER, "__is_member_pointer", 1)
 DEFTRAIT_EXPR (IS_NOTHROW_ASSIGNABLE, "__is_nothrow_assignable", 2)
 DEFTRAIT_EXPR (IS_NOTHROW_CONSTRUCTIBLE, "__is_nothrow_constructible", -1)
 DEFTRAIT_EXPR (IS_NOTHROW_CONVERTIBLE, "__is_nothrow_convertible", 2)
+DEFTRAIT_EXPR (IS_NOTHROW_INVOCABLE, "__builtin_is_nothrow_invocable", -1)
 DEFTRAIT_EXPR (IS_OBJECT, "__is_object", 1)
 DEFTRAIT_EXPR (IS_POINTER_INTERCONVERTIBLE_BASE_OF, "__is_pointer_interconvertible_base_of", 2)
 DEFTRAIT_EXPR (IS_POD, "__is_pod", 1)
diff --git a/gcc/cp/semantics.cc b/gcc/cp/semantics.cc
index 55c2ec4b5b1..5d1acba7bc8 100644
--- a/gcc/cp/semantics.cc
+++ b/gcc/cp/semantics.cc
@@ -12588,6 +12588,9 @@ trait_expr_value (cp_trait_kind kind, tree type1, tree type2)
     case CPTK_IS_NOTHROW_CONVERTIBLE:
       return is_nothrow_convertible (type1, type2);
 
+    case CPTK_IS_NOTHROW_INVOCABLE:
+      return expr_noexcept_p (build_invoke (type1, type2, tf_none), tf_none);
+
     case CPTK_IS_OBJECT:
       return object_type_p (type1);
 
@@ -12723,6 +12726,7 @@ same_type_ref_bind_p (cp_trait_kind kind, tree type1, tree type2)
     case CPTK_IS_NOTHROW_CONSTRUCTIBLE:
     case CPTK_IS_TRIVIALLY_CONSTRUCTIBLE:
     case CPTK_IS_INVOCABLE:
+    case CPTK_IS_NOTHROW_INVOCABLE:
     case CPTK_REF_CONSTRUCTS_FROM_TEMPORARY:
     case CPTK_REF_CONVERTS_FROM_TEMPORARY:
       to = type1;
@@ -12828,6 +12832,7 @@ finish_trait_expr (location_t loc, cp_trait_kind kind, tree type1, tree type2)
     case CPTK_IS_INVOCABLE:
     case CPTK_IS_NOTHROW_CONSTRUCTIBLE:
     case CPTK_IS_NOTHROW_CONVERTIBLE:
+    case CPTK_IS_NOTHROW_INVOCABLE:
     case CPTK_IS_TRIVIALLY_CONSTRUCTIBLE:
     case CPTK_REF_CONSTRUCTS_FROM_TEMPORARY:
     case CPTK_REF_CONVERTS_FROM_TEMPORARY:
diff --git a/gcc/testsuite/g++.dg/ext/has-builtin-1.C b/gcc/testsuite/g++.dg/ext/has-builtin-1.C
index 49e1cd982f5..3395f3f2710 100644
--- a/gcc/testsuite/g++.dg/ext/has-builtin-1.C
+++ b/gcc/testsuite/g++.dg/ext/has-builtin-1.C
@@ -29,6 +29,9 @@
 #if !__has_builtin (__builtin_is_invocable)
 # error "__has_builtin (__builtin_is_invocable) failed"
 #endif
+#if !__has_builtin (__builtin_is_nothrow_invocable)
+# error "__has_builtin (__builtin_is_nothrow_invocable) failed"
+#endif
 #if !__has_builtin (__builtin_is_pointer_interconvertible_with_class)
 # error "__has_builtin (__builtin_is_pointer_interconvertible_with_class) failed"
 #endif
diff --git a/gcc/testsuite/g++.dg/ext/is_nothrow_invocable.C b/gcc/testsuite/g++.dg/ext/is_nothrow_invocable.C
new file mode 100644
index 00000000000..bb84f48d754
--- /dev/null
+++ b/gcc/testsuite/g++.dg/ext/is_nothrow_invocable.C
@@ -0,0 +1,62 @@
+// { dg-do compile { target c++11 } }
+
+#define SA(X) static_assert((X),#X)
+
+using func_type = void(*)();
+SA( ! __builtin_is_nothrow_invocable(func_type) );
+
+#if __cpp_noexcept_function_type
+using func_type_nt = void(*)() noexcept;
+SA(   __builtin_is_nothrow_invocable(func_type_nt) );
+#endif
+
+struct X { };
+using mem_type = int X::*;
+
+SA( ! __builtin_is_nothrow_invocable(mem_type) );
+SA( ! __builtin_is_nothrow_invocable(mem_type, int) );
+SA( ! __builtin_is_nothrow_invocable(mem_type, int&) );
+SA(   __builtin_is_nothrow_invocable(mem_type, X&) );
+
+using memfun_type = int (X::*)();
+
+SA( ! __builtin_is_nothrow_invocable(memfun_type) );
+SA( ! __builtin_is_nothrow_invocable(memfun_type, int) );
+SA( ! __builtin_is_nothrow_invocable(memfun_type, int&) );
+SA( ! __builtin_is_nothrow_invocable(memfun_type, X&) );
+SA( ! __builtin_is_nothrow_invocable(memfun_type, X*) );
+
+#if __cpp_noexcept_function_type
+using memfun_type_nt = int (X::*)() noexcept;
+
+SA( ! __builtin_is_nothrow_invocable(memfun_type_nt) );
+SA( ! __builtin_is_nothrow_invocable(memfun_type_nt, int) );
+SA( ! __builtin_is_nothrow_invocable(memfun_type_nt, int&) );
+SA(   __builtin_is_nothrow_invocable(memfun_type_nt, X&) );
+SA(   __builtin_is_nothrow_invocable(memfun_type_nt, X*) );
+#endif
+
+struct F {
+  int& operator()();
+  long& operator()() const noexcept;
+  short& operator()(int) &&;
+  char& operator()(int) const& noexcept;
+private:
+  void operator()(int, int) noexcept;
+};
+using CF = const F;
+
+SA( ! __builtin_is_nothrow_invocable(F ) );
+SA(   __builtin_is_nothrow_invocable(CF) );
+
+SA( ! __builtin_is_nothrow_invocable(F,   int) );
+SA(   __builtin_is_nothrow_invocable(F&,  int) );
+
+SA(   __builtin_is_nothrow_invocable(CF,   int) );
+SA(   __builtin_is_nothrow_invocable(CF&,  int) );
+SA( ! __builtin_is_nothrow_invocable(F, int, int) );
+
+struct FX {
+  X operator()() const noexcept { return {}; }
+};
+SA(   __builtin_is_nothrow_invocable(FX) );